#pragma once

#include <vector>
#include <chrono>

#include "../renderer/renderer.hpp"
#include "../callback.hpp"
#include "../node/node.hpp"

namespace hibis {
	class Engine {
	public:
		Engine(Renderer* renderer, LoggerCallback logger);
		~Engine();

		void runNodeProcesses();

		void runNodePhysicsProcesses();

		void drawNodes();

		const char* getEngineVersion();
	private:
		Renderer* mRenderer;
		//StopWatch watch;
		std::chrono::time_point<std::chrono::steady_clock> mPreviousProcessTick;
		std::chrono::time_point<std::chrono::steady_clock> mPreviousPhysicsProcessTick;

		std::vector<Node*> mNodeList;
		LoggerCallback mLoggerCallback;
	};
}
